import '../common/isolate_bloc.dart';
import '../common/isolate_bloc_wrapper.dart';

/// Use it to store bloc uuid's and type's in context using provider.
class BlocInfoHolder {
  final _blocsInfo = <Type, IsolateBlocWrapper>{};

  IsolateBlocWrapper getWrapperByType<T extends IsolateBloc>() => _blocsInfo[T];

  void addBlocInfo<T extends IsolateBloc>(IsolateBlocWrapper wrapper) =>
      _blocsInfo[T] = wrapper;

  IsolateBlocWrapper removeBloc<T extends IsolateBloc>() =>
      _blocsInfo.remove(T);

  @override
  String toString() {
    return 'BlocsInfo: $_blocsInfo';
  }
}
